<?php
/*********************************************************************************
 * The contents of this file are subject to the TimeTrex Public License Version
 * 1.1.0 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.TimeTrex.com/TPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by TimeTrex" logo and
 *    (ii) the TimeTrex copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: TimeTrex Open Source
 * The Initial Developer of the Original Code is TimeTrex Payroll Services
 * Portions created by TimeTrex are Copyright (C) 2004-2007 TimeTrex Payroll Services;
 * All Rights Reserved.
 *
 ********************************************************************************/
/*
 * $Revision: 672 $
 * $Id: UserInformation.php 672 2007-02-28 19:41:41Z ipso $
 * $Date: 2007-02-28 11:41:41 -0800 (Wed, 28 Feb 2007) $
 */
require_once('../../includes/global.inc.php');
require_once(Environment::getBasePath() .'includes/Interface.inc.php');

//Debug::setVerbosity(11);

if ( !$permission->Check('report','enabled')
		OR !$permission->Check('report','view_user_information') ) {
	$permission->Redirect( FALSE ); //Redirect
}

$title = 'Employee Information Report';
$smarty->assign('title', $title);


/*
 * Get FORM variables
 */
extract	(FormVariables::GetVariables(
										array	(
												'action',
												'generic_data',
												'filter_data'

												) ) );

//Debug::Arr($action, 'Action', __FILE__, __LINE__, __METHOD__,10);
//Debug::Arr($filter_data, 'Filter Data', __FILE__, __LINE__, __METHOD__,10);


URLBuilder::setURL($_SERVER['SCRIPT_NAME'],
											array(
													'filter_data' => $filter_data
//													'sort_column' => $sort_column,
//													'sort_order' => $sort_order,
												) );


$columns = array(
											'-1010-employee_number' => 'Employee #',
											'-1020-status' => 'Status',
											'-1030-user_name' => 'User Name',
											'-1040-phone_id' => 'Phone ID',
											'-1050-ibutton_id' => 'iButton',

											'-1060-first_name' => 'First Name',
											'-1070-middle_name' => 'Middle Name',
											'-1080-last_name' => 'Last Name',

											'-1090-title' => 'Title',

											'-1099-group' => 'Group',						
											'-1100-default_branch' => 'Branch',
											'-1110-default_department' => 'Department',
											
											'-1115-policy_group' => 'Policy Group',
											'-1118-pay_period_schedule' => 'Pay Period Schedule',
											
											'-1120-sex' => 'Sex',

											'-1130-address1' => 'Address 1',
											'-1140-address2' => 'Address 2',

											'-1150-city' => 'City',
											'-1160-province' => 'Province/State',
											'-1170-country' => 'Country',
											'-1180-postal_code' => 'Postal Code',
											'-1190-work_phone' => 'Work Phone',
											'-1200-home_phone' => 'Home Phone',
											'-1210-mobile_phone' => 'Mobile Phone',
											'-1220-fax_phone' => 'Fax Phone',
											'-1230-home_email' => 'Home Email',
											'-1240-work_email' => 'Work Email',
											'-1250-birth_date' => 'Birth Date',
											'-1260-hire_date' => 'Hire Date',
											'-1270-termination_date' => 'Termination Date',
											'-1280-sin' => 'SIN/SSN',

											'-1290-institution' => 'Bank Instituion',
											'-1300-transit' => 'Bank Transit',
											'-1310-account' => 'Bank Account',

											//'-1319-currency' => 'Currency',
											'-1320-wage_type' => 'Wage Type',
											'-1330-wage' => 'Wage',
											'-1340-effective_date' => 'Wage Effective Date',
											);

if ( !isset($filter_data['include_user_ids']) ) {
	$filter_data['include_user_ids'] = array();
}
if ( !isset($filter_data['exclude_user_ids']) ) {
	$filter_data['exclude_user_ids'] = array();
}
if ( !isset($filter_data['user_status_ids']) ) {
	$filter_data['user_status_ids'] = array();
}
if ( !isset($filter_data['group_ids']) ) {
	$filter_data['group_ids'] = array();
}
if ( !isset($filter_data['branch_ids']) ) {
	$filter_data['branch_ids'] = array();
}
if ( !isset($filter_data['department_ids']) ) {
	$filter_data['department_ids'] = array();
}
if ( !isset($filter_data['user_title_ids']) ) {
	$filter_data['user_title_ids'] = array();
}
if ( !isset($filter_data['columns']) ) {
	$filter_data['columns'] = array();
}

//Company Deductions
$cdlf = new CompanyDeductionListFactory();
$deduction_columns = $cdlf->getByCompanyIdAndStatusIdArray( $current_company->getId(), 10, FALSE);

$columns = Misc::prependArray( $columns, $deduction_columns);

//Get Permission Hierarchy Children first, as this can be used for viewing, or editing.
$permission_children_ids = array();
if ( $permission->Check('user','view') == FALSE ) {
	$hlf = new HierarchyListFactory();
	$permission_children_ids = $hlf->getHierarchyChildrenByCompanyIdAndUserIdAndObjectTypeID( $current_company->getId(), $current_user->getId() );
	
	if ( $permission->Check('user','view_child') == FALSE ) {
		$permission_children_ids = array();
	}
	if ( $permission->Check('user','view_own') ) {
		$permission_children_ids[] = $current_user->getId();
	}
	
	$filter_data['permission_children_ids'] = $permission_children_ids;	
}

$ugdlf = new UserGenericDataListFactory();
$ugdf = new UserGenericDataFactory();

$action = strtolower($action);

switch ($action) {
	case 'export':
	case 'display report':
		Debug::Text('Submit!', __FILE__, __LINE__, __METHOD__,10);
		//Debug::Arr($filter_data, 'Filter Data', __FILE__, __LINE__, __METHOD__,10);


		//Get all employees that match the criteria:
		$ulf = new UserListFactory();
		$ulf->getSearchByCompanyIdAndArrayCriteria( $current_company->getId(), $filter_data );
		if ( $ulf->getRecordCount() > 0 ) {
			foreach( $ulf as $u_obj ) {
				$filter_data['user_ids'][] = $u_obj->getId();
			}

			$ulf->getReportByCompanyIdAndUserIDList( $current_company->getId(), $filter_data['user_ids'] );

			//Get title list,
			$utlf = new UserTitleListFactory();
			$user_titles = $utlf->getByCompanyIdArray( $current_company->getId() );

			$uglf = new UserGroupListFactory();
			$group_options = $uglf->getArrayByNodes( FastTree::FormatArray( $uglf->getByCompanyIdArray( $current_company->getId() ), 'no_tree_text', TRUE) );

			//Get default branch list
			$blf = new BranchListFactory();
			$branch_options = $blf->getByCompanyIdArray( $current_company->getId() );

			$dlf = new DepartmentListFactory();
			$department_options = $dlf->getByCompanyIdArray( $current_company->getId() );

			$ppslf = new PayPeriodScheduleListFactory();
			$pay_period_schedule_options = $ppslf->getByCompanyIDArray( $current_company->getId() );

			$pglf = new PolicyGroupListFactory();
			$policy_group_options = $pglf->getByCompanyIDArray( $current_company->getId() );

			$ppslf = new PayPeriodScheduleListFactory();
			$ppslf->getByCompanyIdAndUserId( $current_company->getId(), $filter_data['user_ids'] );
			$pay_period_schedule_user_map = $ppslf->getUserToPayPeriodScheduleMapArrayByListFactory( $ppslf );
			
			$pglf = new PolicyGroupListFactory();
			$pglf->getByCompanyIdAndUserId( $current_company->getId(), $filter_data['user_ids'] );
			$policy_group_user_map = $pglf->getUserToPolicyGroupMapArrayByListFactory( $pglf );
/*
			$crlf = new CurrencyListFactory();
			$crlf->getByCompanyId( $current_company->getId() );
			$currency_options = $crlf->getArrayByListFactory( $crlf, FALSE, TRUE );
*/
			$uwlf = new UserWageListFactory();
			$uwlf->getLastWageByUserIdAndDate( $filter_data['user_ids'], TTDate::getTime() );
			if ( $uwlf->getRecordCount() > 0 ) {
				foreach($uwlf as $uw_obj) {
					$user_wage[$uw_obj->getUser()] = array(
															'type_id' => $uw_obj->getType(),
															'type' => Option::getByKey($uw_obj->getType(), $uw_obj->getOptions('type') ),
															'wage' => $uw_obj->getWage(),
															'effective_date' => $uw_obj->getEffectiveDate(),
															//'effective_date' => TTDate::getDate('DATE', $uw_obj->getEffectiveDate() )
															);
				}
				//var_dump($user_wage);
			}

			$udlf = new UserDeductionListFactory();
			$udlf->getByCompanyIdAndUserId( $current_company->getId(), $filter_data['user_ids']);
			if ( $udlf->getRecordCount() > 0 ) {
				foreach( $udlf as $ud_obj ) {
					//Get UserValue options
					$user_value_1_options = $ud_obj->getCompanyDeductionObject()->getUserValue1Options();

					if ( $ud_obj->getUserValue1() !== FALSE ) {
						$tmp_user_value = $ud_obj->getUserValue1();
					} elseif ( $ud_obj->getCompanyDeductionObject()->getUserValue1() ) {
						$tmp_user_value = $ud_obj->getCompanyDeductionObject()->getUserValue1();
					} else {
						$tmp_user_value = NULL;
					}

					if ( is_array($user_value_1_options) ) {
						$user_values[] = Option::getByKey( $tmp_user_value, $user_value_1_options );
					} else {
						$user_values[] = $tmp_user_value;
					}
					unset($tmp_user_value);

					if ( $ud_obj->getUserValue2() !== FALSE ) {
						$user_values[] = $ud_obj->getUserValue2();
					} elseif ( $ud_obj->getCompanyDeductionObject()->getUserValue2() ) {
						$user_values[] = $ud_obj->getCompanyDeductionObject()->getUserValue2();
					}

					if ( $ud_obj->getUserValue3() !== FALSE ) {
						$user_values[] = $ud_obj->getUserValue3();
					} elseif ( $ud_obj->getCompanyDeductionObject()->getUserValue3() ) {
						$user_values[] = $ud_obj->getCompanyDeductionObject()->getUserValue3();
					}

					if ( isset($user_values) ) {
						$user_value_str = implode(' / ', $user_values);
					} else {
						$user_value_str = 'N/A';
					}

					$user_deduction[$ud_obj->getUser()][$ud_obj->getCompanyDeduction()] = $user_value_str;

					unset($user_value_str, $user_values);
				}
			}
			//var_dump($user_deduction);

			foreach ($ulf as $u_obj ) {
				//Wage data
				if ( isset($user_wage[$u_obj->getId()]) ) {
					//Debug::Text('Wage Data found for User ID: '. $u_obj->getId(), __FILE__, __LINE__, __METHOD__,10);
					$user_wage_data = $user_wage[$u_obj->getId()];
				} else {
					Debug::Text('No Wage Data found for User ID: '. $u_obj->getId(), __FILE__, __LINE__, __METHOD__,10);
					//Dummy array
					$user_wage_data = array(
											'type_id' => NULL,
											'type' => NULL,
											'wage' => NULL,
											'effective_date_order' => NULL,
											'effective_date' => NULL
											);
				}
				
				if ( isset($policy_group_user_map[$u_obj->getId()]) ) {;
					$policy_group_id = $policy_group_user_map[$u_obj->getId()];
				} else {
					$policy_group_id = 0;
				}
				
				if ( isset($pay_period_schedule_user_map[$u_obj->getId()]) ) {;
					$pay_period_schedule_id = $pay_period_schedule_user_map[$u_obj->getId()];
				} else {
					$pay_period_schedule_id = 0;
				}
				
				$row_arr = array(
									'id' => $u_obj->getId(),
									'employee_number' => $u_obj->getEmployeeNumber(),
									'status' => Option::getByKey( $u_obj->getStatus(), $u_obj->getOptions('status') ),
									'user_name' => $u_obj->getUserName(),
									'phone_id' => $u_obj->getPhoneID(),
									'ibutton_id' => $u_obj->getIButtonID(),

									'first_name' => $u_obj->getFirstName(),
									'middle_name' => $u_obj->getMiddleName(),
									'last_name' => $u_obj->getLastName(),

									'title' => Option::getByKey($u_obj->getTitle(), $user_titles ),

									'group' => Option::getByKey($u_obj->getGroup(), $group_options ),
									'default_branch' => Option::getByKey($u_obj->getDefaultBranch(), $branch_options ),
									'default_department' => Option::getByKey($u_obj->getDefaultDepartment(), $department_options ),
									
									'policy_group' => Option::getByKey( $policy_group_id, $policy_group_options ),
									'pay_period_schedule' => Option::getByKey( $pay_period_schedule_id, $pay_period_schedule_options ),

									'sex' => Option::getByKey($u_obj->getSex(), $u_obj->getOptions('sex') ),

									'address1' => $u_obj->getAddress1(),
									'address2' => $u_obj->getAddress2(),
									'city' => $u_obj->getCity(),
									'province' => $u_obj->getProvince(),
									'country' => $u_obj->getCountry(),
									'postal_code' => $u_obj->getPostalCode(),
									'work_phone' => $u_obj->getWorkPhone(),
									'home_phone' => $u_obj->getHomePhone(),
									'mobile_phone' => $u_obj->getMobilePhone(),
									'fax_phone' => $u_obj->getFaxPhone(),
									'home_email' => $u_obj->getHomeEmail(),
									'work_email' => $u_obj->getWorkEmail(),
									'birth_date' => $u_obj->getBirthDate(),
									'sin' => $u_obj->getSIN(),
									'hire_date' => $u_obj->getHireDate(),
									'termination_date' => $u_obj->getTerminationDate(),

									//Bank Info
									'institution' => $u_obj->getColumn('institution'),
									'transit' => $u_obj->getColumn('transit'),
									'account' => $u_obj->getColumn('account'),

									//Wage info
									//'currency' => Option::getByKey($u_obj->getCurrency(), $currency_options ),
									'wage_type' => $user_wage_data['type'],
									'wage' => $user_wage_data['wage'],
									//'effective_date_order' => $user_wage_data['effective_date_order'],
									'effective_date' => $user_wage_data['effective_date'],
								);

				if ( isset($user_deduction[$u_obj->getId()]) ) {
					$row_arr = Misc::prependArray( $row_arr, $user_deduction[$u_obj->getId()] );
				}

				$tmp_rows[] = $row_arr;
			}

			$tmp_rows = Sort::Multisort($tmp_rows, Misc::trimSortPrefix($filter_data['primary_sort']), Misc::trimSortPrefix($filter_data['secondary_sort']), $filter_data['primary_sort_dir'], $filter_data['secondary_sort_dir']);
		} else {
			//No Users!
		}

		if ( isset($tmp_rows) ) {
			foreach($tmp_rows as $tmp_row ) {
				foreach($tmp_row as $column => $column_data) {
					if ( $column_data != '' AND strstr($column, '_date') ) {
						$column_data = TTDate::getDate('DATE', $column_data);
					}

					$row_columns[$column] = $column_data;
					unset($column, $column_data);
				}

				$rows[] = $row_columns;
				unset($row_columns);
			}
		}
		unset($tmp_rows);

		foreach( $filter_data['columns'] as $column_key ) {
			$filter_columns[Misc::trimSortPrefix($column_key)] = $columns[$column_key];
		}

		if ( $action == 'export' ) {
			if ( isset($rows) AND isset($filter_columns) ) {
				Debug::Text('Exporting as CSV', __FILE__, __LINE__, __METHOD__,10);
				$data = Misc::Array2CSV( $rows, $filter_columns, FALSE );

				Misc::FileDownloadHeader('report.csv', 'application/csv', strlen($data) );
				echo $data;
			} else {
				echo "No Data To Export!<br>\n";
			}
		} else {
			$smarty->assign_by_ref('generated_time', TTDate::getTime() );
			$smarty->assign_by_ref('columns', $filter_columns );
			$smarty->assign_by_ref('rows', $rows);

			$smarty->display('report/UserInformationReport.tpl');
		}

		break;
	case 'delete':
	case 'save':
		Debug::Text('Action: '. $action, __FILE__, __LINE__, __METHOD__,10);

		$generic_data['id'] = UserGenericDataFactory::reportFormDataHandler( $action, $filter_data, $generic_data, URLBuilder::getURL(NULL, $_SERVER['SCRIPT_NAME']) );
		unset($generic_data['name']);
	default:
		BreadCrumb::setCrumb($title);

		if ( $action == 'load' ) {
			Debug::Text('Loading Report!', __FILE__, __LINE__, __METHOD__,10);
			extract( UserGenericDataFactory::getReportFormData( $generic_data['id'] ) );
		} elseif ( $action == '' ) {
			//Check for default saved report first.
			$ugdlf->getByUserIdAndScriptAndDefault( $current_user->getId(), $_SERVER['SCRIPT_NAME'] );
			if ( $ugdlf->getRecordCount() > 0 ) {
				Debug::Text('Found Default Report!', __FILE__, __LINE__, __METHOD__,10);

				$ugd_obj = $ugdlf->getCurrent();
				$filter_data = $ugd_obj->getData();
				$generic_data['id'] = $ugd_obj->getId();
			} else {
				//Default selections
				//$filter_data['user_ids'] = array_keys( UserListFactory::getByCompanyIdArray( $current_company->getId(), FALSE, FALSE ) );
				$filter_data['user_status_ids'] = array( -1 );
				$filter_data['branch_ids'] = array( -1 );
				$filter_data['department_ids'] = array( -1 );
				$filter_data['user_title_ids'] = array( -1 );
				$filter_data['group_ids'] = array( -1 );

				$filter_data['columns'] = array(
												'-1060-first_name',
												'-1080-last_name',
												'-1090-title',
												'-1200-home_phone',
												'-1130-address1',
												'-1150-city',
												'-1160-province',
												'-1180-postal_code',
												);

				$filter_data['primary_sort'] = '-1080-last_name';
				$filter_data['secondary_sort'] = '-1160-province';
			}
		}

		$ulf = new UserListFactory();
		$all_array_option = array('-1' => '-- All --');

		//Get include employee list.
		if ( !isset($filter_data['include_user_ids']) ) {
				$filter_data['include_user_ids'] = NULL;
		}																
		$ulf->getSearchByCompanyIdAndArrayCriteria( $current_company->getId(), array('permission_children_ids' => $permission_children_ids ) );
		$user_options = $ulf->getArrayByListFactory( $ulf, FALSE, TRUE );		
		$filter_data['src_include_user_options'] = Misc::arrayDiffByKey( (array)$filter_data['include_user_ids'], $user_options );
		$filter_data['selected_include_user_options'] = Misc::arrayIntersectByKey( (array)$filter_data['include_user_ids'], $user_options );
		
		//Get exclude employee list
		if ( !isset($filter_data['exclude_user_ids']) ) {
				$filter_data['exclude_user_ids'] = NULL;
		}														
		$exclude_user_options = Misc::prependArray( $all_array_option, $ulf->getArrayByListFactory( $ulf, FALSE, TRUE ) );
		$filter_data['src_exclude_user_options'] = Misc::arrayDiffByKey( (array)$filter_data['exclude_user_ids'], $user_options );
		$filter_data['selected_exclude_user_options'] = Misc::arrayIntersectByKey( (array)$filter_data['exclude_user_ids'], $user_options );

		//Get employee status list.
		if ( !isset($filter_data['user_status_ids']) ) {
				$filter_data['user_status_ids'] = NULL;
		}												
		$user_status_options = Misc::prependArray( $all_array_option, $ulf->getOptions('status') );
		$filter_data['src_user_status_options'] = Misc::arrayDiffByKey( (array)$filter_data['user_status_ids'], $user_status_options );
		$filter_data['selected_user_status_options'] = Misc::arrayIntersectByKey( (array)$filter_data['user_status_ids'], $user_status_options );

		//Get Employee Groups
		if ( !isset($filter_data['group_ids']) ) {
				$filter_data['group_ids'] = NULL;
		}										
		$uglf = new UserGroupListFactory();
		$group_options = Misc::prependArray( $all_array_option, $uglf->getArrayByNodes( FastTree::FormatArray( $uglf->getByCompanyIdArray( $current_company->getId() ), 'TEXT', TRUE) ) );
		$filter_data['src_group_options'] = Misc::arrayDiffByKey( (array)$filter_data['group_ids'], $group_options );
		$filter_data['selected_group_options'] = Misc::arrayIntersectByKey( (array)$filter_data['group_ids'], $group_options );

		//Get branches
		if ( !isset($filter_data['branch_ids']) ) {
				$filter_data['branch_ids'] = NULL;
		}								
		$blf = new BranchListFactory();
		$blf->getByCompanyId( $current_company->getId() );
		$branch_options = Misc::prependArray( $all_array_option, $blf->getArrayByListFactory( $blf, FALSE, TRUE ) );
		$filter_data['src_branch_options'] = Misc::arrayDiffByKey( (array)$filter_data['branch_ids'], $branch_options );
		$filter_data['selected_branch_options'] = Misc::arrayIntersectByKey( (array)$filter_data['branch_ids'], $branch_options );

		//Get departments
		if ( !isset($filter_data['department_ids']) ) {
				$filter_data['department_ids'] = NULL;
		}						
		$dlf = new DepartmentListFactory();
		$dlf->getByCompanyId( $current_company->getId() );
		$department_options = Misc::prependArray( $all_array_option, $dlf->getArrayByListFactory( $dlf, FALSE, TRUE ) );
		$filter_data['src_department_options'] = Misc::arrayDiffByKey( (array)$filter_data['department_ids'], $department_options );
		$filter_data['selected_department_options'] = Misc::arrayIntersectByKey( (array)$filter_data['department_ids'], $department_options );

		//Get employee titles
		if ( !isset($filter_data['user_title_ids']) ) {
				$filter_data['user_title_ids'] = NULL;
		}				
		$utlf = new UserTitleListFactory();
		$utlf->getByCompanyId( $current_company->getId() );
		$user_title_options = Misc::prependArray( $all_array_option, $utlf->getArrayByListFactory( $utlf, FALSE, TRUE ) );
		$filter_data['src_user_title_options'] = Misc::arrayDiffByKey( (array)$filter_data['user_title_ids'], $user_title_options );
		$filter_data['selected_user_title_options'] = Misc::arrayIntersectByKey( (array)$filter_data['user_title_ids'], $user_title_options );

		//Get column list
		if ( !isset($filter_data['columns']) ) {
				$filter_data['columns'] = NULL;
		}		
		$filter_data['src_column_options'] = Misc::arrayDiffByKey( (array)$filter_data['columns'], $columns );
		$filter_data['selected_column_options'] = Misc::arrayIntersectByKey( (array)$filter_data['columns'], $columns );

		//Get primary/secondary order list
		$filter_data['sort_options'] = $columns;
		$filter_data['sort_options']['effective_date_order'] = 'Wage Effective Date';
		unset($filter_data['sort_options']['effective_date']);

		$filter_data['sort_direction_options'] = Misc::getSortDirectionArray();
		
		$saved_report_options = $ugdlf->getByUserIdAndScriptArray( $current_user->getId(), $_SERVER['SCRIPT_NAME']);
		$generic_data['saved_report_options'] = $saved_report_options;
		$smarty->assign_by_ref('generic_data', $generic_data);

		$smarty->assign_by_ref('filter_data', $filter_data);

		$smarty->assign_by_ref('ugdf', $ugdf);

		//var_dump($filter_data);

		$smarty->display('report/UserInformation.tpl');

		break;
}
?>