<?php
/*********************************************************************************
 * The contents of this file are subject to the TimeTrex Public License Version
 * 1.1.0 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.TimeTrex.com/TPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by TimeTrex" logo and
 *    (ii) the TimeTrex copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: TimeTrex Open Source
 * The Initial Developer of the Original Code is TimeTrex Payroll Services
 * Portions created by TimeTrex are Copyright (C) 2004-2007 TimeTrex Payroll Services;
 * All Rights Reserved.
 *
 ********************************************************************************/
/*
 * $Revision: 4 $
 * $Id: UserTitleList.php 4 2006-08-07 23:04:34Z ipso $
 * $Date: 2006-08-07 16:04:34 -0700 (Mon, 07 Aug 2006) $
 */
require_once('../../includes/global.inc.php');
require_once(Environment::getBasePath() .'includes/Interface.inc.php');

if ( !$permission->Check('user','enabled')
		OR !( $permission->Check('user','view') ) ) {

	$permission->Redirect( FALSE ); //Redirect

}

$title = 'Employee Title List';
$smarty->assign('title', $title );
BreadCrumb::setCrumb($title);

/*
 * Get FORM variables
 */
extract	(FormVariables::GetVariables(
										array	(
												'action',
												'page',
												'sort_column',
												'sort_order',
												'ids'
												) ) );

URLBuilder::setURL($_SERVER['SCRIPT_NAME'],
											array(
													'sort_column' => $sort_column,
													'sort_order' => $sort_order,
													'page' => $page
												) );

Debug::Arr($ids,'Selected Objects', __FILE__, __LINE__, __METHOD__,10);

switch (strtolower($action)) {
	case 'add':

		Redirect::Page( URLBuilder::getURL(NULL, 'EditUserTitle.php') );

		break;
	case 'delete' OR 'undelete':
		if ( strtolower($action) == 'delete' ) {
			$delete = TRUE;
		} else {
			$delete = FALSE;
		}

		$utlf = new UserTitleListFactory();

		foreach ($ids as $id) {
			$utlf->GetByIdAndCompanyId($id, $current_company->getId() );
			foreach ($utlf as $title_obj) {
				$title_obj->setDeleted($delete);
				$title_obj->Save();
			}
		}

		Redirect::Page( URLBuilder::getURL(NULL, 'UserTitleList.php') );

		break;

	default:
		$utlf = new UserTitleListFactory();

		$utlf->getByCompanyId($current_company->getId(), $current_user_prefs->getItemsPerPage(),$page, NULL, array($sort_column => $sort_order) );

		$pager = new Pager($utlf);

		foreach ($utlf as $title_obj) {

			$titles[] = array(
								'id' => $title_obj->GetId(),
								'name' => $title_obj->getName(),
								'deleted' => $title_obj->getDeleted()
							);

		}
		$smarty->assign_by_ref('titles', $titles);

		$smarty->assign_by_ref('sort_column', $sort_column );
		$smarty->assign_by_ref('sort_order', $sort_order );

		$smarty->assign_by_ref('paging_data', $pager->getPageVariables() );

		break;
}
$smarty->display('users/UserTitleList.tpl');
?>